<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Customizations.ascx.cs" Inherits="Admin_Controls_Customizations" %>

<asp:Menu
    id="Menu1"
    Orientation="Horizontal"
    StaticMenuItemStyle-CssClass="tab"
    StaticSelectedStyle-CssClass="selectedTab"
    CssClass="tabs"
    Runat="server" OnMenuItemClick="Menu1_MenuItemClick">
    <Items>
    <asp:MenuItem Text="Customizations" Value="0" Selected="true" />
    <asp:MenuItem Text="Add/Edit Customization" Value="1" />
    <asp:MenuItem Text="Reuse Customization" Value="2" />
    </Items>    
</asp:Menu>

<div class="tabContents">
    <asp:MultiView ID="mvContent" runat="Server" ActiveViewIndex="0">
        <asp:View ID="vwCustomizations" runat="server">
            <table>
                <tr>
                    <td>
                        <asp:GridView ID="gvCustomizations" runat="server" GridLines="None" DataKeyNames="CustomizationID" AutoGenerateColumns="false" CellSpacing="5" EmptyDataText="There are no customizations currently associated with this product page.  Use the tabs at the top to add existing or new customizations." OnRowCommand="gvCustomizations_RowCommand">
                            <HeaderStyle Font-Size="Small" Font-Bold="false" />
                            <Columns>
                                <asp:TemplateField ItemStyle-Width="40px">
                                    <ItemTemplate><asp:CheckBox ID="cbSelect" runat="server" /></ItemTemplate>
                                </asp:TemplateField>
                                <asp:BoundField DataField="Name" HeaderText="Name" ItemStyle-Width="180px" />
                                <asp:BoundField DataField="Prompt" HeaderText="Prompt" ItemStyle-Width="290px" />
                                <asp:ButtonField ButtonType="Link" CommandName="ed" Text="[Edit]" ItemStyle-Width="180px" />
                            </Columns>
                        </asp:GridView>
                        
                        <% if (gvCustomizations.Rows.Count > 0) { %>
                        <asp:Button ID="btnRemoveSelected" runat="server" Text="Remove Selected" OnClick="btnRemoveSelected_Click" />
                        <% } %>
                    </td>
                </tr>
            </table>
        </asp:View>
        <asp:View ID="vwAddCustomization" runat="Server">        
            <table>
                <tr>
                    <td style="width: 200px;"></td>
                    <td style="width: 400px;"></td>
                </tr>
                <tr>
                    <td>Customization ID:</td>
                    <td>
                        <asp:Literal ID="litCustomizationID" runat="Server" Text="New Customization" />
                    </td>
                </tr>
                <tr valign="top">
                    <td>Name:</td>
                    <td>
                        <asp:TextBox ID="txtName" runat="server" MaxLength="255" Width="300px" />
                        <div>
                            <asp:RequiredFieldValidator ID="reqName" runat="server" ControlToValidate="txtName" ErrorMessage="Please enter a name for this customization." Display="Dynamic" />
                        </div>
                    </td>
                </tr>
                <tr valign="top">
                    <td>Prompt:</td>
                    <td>
                        <asp:TextBox ID="txtPrompt" runat="server" MaxLength="255" Width="300px" />
                        <div>
                            <asp:RequiredFieldValidator ID="reqPrompt" runat="server" ControlToValidate="txtPrompt" ErrorMessage="Please enter a prompt.  If you are unsure of what to use, use the name you entered in the box above." Display="Dynamic" />
                        </div>
                    </td>
                </tr>
                <tr valign="top">
                    <td>Control Type:</td>
                    <td>
                        <asp:DropDownList ID="ddlControlType" runat="server" AutoPostBack="True" Width="304px">
                            <asp:ListItem Value="1">Drop Down List</asp:ListItem>
                            <asp:ListItem Value="2">Check Box List</asp:ListItem>
                            <asp:ListItem Value="3">Text Box</asp:ListItem>
                            <asp:ListItem Value="4">Large Text Box</asp:ListItem>
                            <asp:ListItem Value="5">File Upload</asp:ListItem>
                        </asp:DropDownList>
                    </td>
                </tr>
                <% if (ddlControlType.SelectedValue == "1" || ddlControlType.SelectedValue == "2") { %>
                <tr valign="top">
                    <td>Options:</td>
                    <td>
                        <asp:CustomValidator ID="custOptions" runat="server" Display="Dynamic" ErrorMessage="Please ensure that each row is either completely filled out or completely blank, and that you have entered valid numbers in the price column." OnServerValidate="custOptions_ServerValidate" />
                        <asp:GridView ID="gvOptions" runat="server" GridLines="None" AutoGenerateColumns="false" DataKeyNames="CustomizationOptionID">
                            <Columns>
                                <WebBlocks:TextBoxField DataField="OptionName" HeaderText="Option Name" ItemStyle-Width="200px" />
                                <WebBlocks:TextBoxField DataField="Price" HeaderText="Price" DataFormatString="{0:f}" ItemStyle-Width="60px" />
                            </Columns>
                        </asp:GridView>
                        <asp:LinkButton ID="btnAddMore" runat="server" Text="Add Another Option" OnClick="btnAddMore_Click1" CausesValidation="False" />
                    </td>
                </tr>
                <% } %>
                <tr valign="top">
                    <td></td>
                    <td>
                        <br />
                        <asp:Button ID="btnSubmit" runat="server" Text="Save" OnClick="btnSubmit_Click" />
                    </td>
                </tr>
            </table>
        </asp:View>
        <asp:View ID="vwReuseCustomization" runat="Server">
            This tool enables you to reuse a customization from another product page.
            <table>
                <tr>
                    <td>Category:</td>
                    <td><asp:DropDownList ID="ddlCategory" runat="server" DataTextField="CanonicalName" DataValueField="CategoryID" AutoPostBack="True" OnSelectedIndexChanged="ddlCategory_SelectedIndexChanged" /></td>
                </tr>
                <tr>
                    <td>Product Page:</td>
                    <td><asp:DropDownList ID="ddlSelector" runat="server" DataTextField="Name" DataValueField="SelectorID" AutoPostBack="True" Enabled="false" OnSelectedIndexChanged="ddlSelector_SelectedIndexChanged" /></td>
                </tr>
                <tr>
                    <td>Customization:</td>
                    <td><asp:DropDownList ID="ddlCustomization" runat="server" DataTextField="Name" DataValueField="CustomizationID" Enabled="false" /></td>
                </tr>
                <tr>
                    <td></td>
                    <td><asp:Button ID="btnCopy" runat="server" Text="Copy Customization Details" OnClick="btnCopy_Click" /></td>
                </tr>
            </table>
        </asp:View>
    </asp:MultiView>
</div>

