<%@ Control Language="C#" AutoEventWireup="true" CodeFile="EditItem.ascx.cs" Inherits="Admin_Controls_EditItem" %>

<table>
    <tr valign="top">
        <td>
            <table>
                <tr>
                    <td style="width: 150px"></td>
                </tr>
                <tr>
                    <td style="width: 100px;">
                        Item ID
                    </td>
                    <td>
                        <b><asp:Literal ID="litItemID" runat="server" Text="New Item" /></b>
                    </td>
                </tr>
                <tr>
                    <td>*SKU</td>
                    <td>
                        <asp:TextBox ID="txtAddSKU" runat="server" Width="230px" />
                        <div>
                            <asp:RequiredFieldValidator ID="reqSKU" runat="server" ControlToValidate="txtAddSKU" Display="Dynamic" ErrorMessage="Please enter a SKU." ValidationGroup="addItem" />
                            <asp:CustomValidator OnServerValidate="SKUCheck" ID="custSKU" runat="server" ControlToValidate="txtAddSKU" Display="Dynamic" ErrorMessage="This SKU is already in use." ValidationGroup="addItem" />
                        </div>                    
                    </td>
                </tr>
                <tr>
                    <td>*Name</td>
                    <td>
                        <asp:TextBox ID="txtAddName" runat="server" Width="230px" />
                        <div>
                            <asp:RequiredFieldValidator ID="reqName" runat="server" ControlToValidate="txtAddName" Display="Dynamic" ErrorMessage="Please enter a name." ValidationGroup="addItem" />
                        </div>
                    </td>
                </tr>
                <tr>
                    <td>*Price</td>
                    <td>
                        <asp:TextBox ID="txtAddPrice" runat="server" Width="230px" Text="0.00" />
                        <div>
                            <asp:RequiredFieldValidator ID="reqPrice" runat="server" ControlToValidate="txtAddPrice" Display="Dynamic" ErrorMessage="Please enter a price." ValidationGroup="addItem" />
                            <asp:CompareValidator ID="cmpPrice" runat="server" ControlToValidate="txtAddPrice" Operator="DataTypeCheck" Type="Double" Display="Dynamic" ErrorMessage="Please enter a valid price, without the dollar sign ($)." ValidationGroup="addItem" />
                        </div>
                    </td>
                </tr>
                <tr>
                    <td>Volume Pricing</td>
                    <td>
                        <asp:DropDownList ID="ddlVolumePricingTable" runat="server" DataTextField="Name" DataValueField="VolumePricingTableID" Width="230px" AutoPostBack="true" CausesValidation="false" ValidationGroup="addItem" />
                    </td>
                </tr>
                <tr>
                    <td>*Weight (lbs)</td>
                    <td>
                        <asp:TextBox ID="txtAddWeight" runat="server" Width="230px" Text="1" />
                        <div>
                            <asp:RequiredFieldValidator ID="reqWeight" runat="server" ControlToValidate="txtAddWeight" Display="Dynamic" ErrorMessage="Please enter a weight." ValidationGroup="addItem" />
                            <asp:CompareValidator ID="cmpWeight" runat="server" ControlToValidate="txtAddWeight" Operator="DataTypeCheck" Type="Double" Display="Dynamic" ErrorMessage="Please enter a valid weight, in pounds." ValidationGroup="addItem" />
                        </div>
                    </td>
                        
                </tr>
                <tr>
                    <td>*Inventory (put '-1' for no limit)</td>
                    <td>
                        <asp:TextBox ID="txtAddInventory" runat="server" Width="30px" Text="-1" />
                        <div>
                            <asp:RequiredFieldValidator ID="reqInventory" runat="server" ControlToValidate="txtAddInventory" Display="Dynamic" ErrorMessage="Please enter an inventory amount. (-1 = disable inventory control)" ValidationGroup="addItem" />
                            <asp:CompareValidator ID="cmpInventory" runat="server" ControlToValidate="txtAddInventory" Operator="DataTypeCheck" Type="Integer" Display="Dynamic" ErrorMessage="Please enter a valid number." ValidationGroup="addItem" />
                        </div>
                    </td>
                </tr>
                <tr>
                    <td>Send me and email when inventory goes below: </td>
                    <td>
                        <asp:TextBox ID="txtLowInventory" runat="server" Width="30px" Text="-1" /> (Enter -1 to disable e-mail)
                        <div>
                            <asp:CompareValidator ID="cmpLowInventory" runat="server" ControlToValidate="txtLowInventory" Operator="DataTypeCheck" Type="Integer" Display="Dynamic" ErrorMessage="Please enter a valid number. (-1 = disable e-mail)" ValidationGroup="addItem" />
                        </div>
                    </td>
                </tr>
                <tr>
                    <td>Active?</td>
                    <td><asp:CheckBox ID="chkActive" runat="server" Checked="True" CausesValidation="false" /></td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td colspan="2">
            <asp:Button ID="btnCancelAddItem" runat="server" Text="Cancel" OnClick="btnCancelAddItem_Click" />
            <asp:Button ID="btnAddItem" runat="server" Text="Save Item" OnClick="btnAddItem_Click" ValidationGroup="addItem" />
        </td>
    </tr>
</table>