using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_Controls_OrderContents : WebBlockUserControl
{
    public int OrderID
    {
        get { return (ViewState["OrderID"] == null ? 0 : (int)ViewState["OrderID"]); }
        set { ViewState["OrderID"] = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        
    }

    public void BindData()
    {
        DataTable dt = Database.OrderItems_GetForAdmin(OrderID);
        gvOrderContents.DataSource = dt;
        gvOrderContents.DataBind();

        decimal subTotal = 0;
        foreach(DataRow drx in dt.Rows)
            subTotal += (decimal)drx["Cost"];

        // bind Discounts
        DataTable dtDiscounts = Database.OrderDiscounts_GetByOrderID(OrderID);
        rptDiscounts.DataSource = dtDiscounts;
        rptDiscounts.DataBind();

        DataRow dr = Database.Orders_GetByOrderID(OrderID);

        litSubTotal.Text = String.Format("{0:c}", subTotal);
        litSalesTax.Text = String.Format("{0:c}", (decimal)dr["TaxAmount"]);
        litShippingMethod.Text = (dr["ShippingMethod"] == DBNull.Value ? "" : (string)dr["ShippingMethod"]);
        litShippingAmount.Text = String.Format("{0:c}", (decimal)dr["ShippingAmount"]);
        litAmount.Text = String.Format("{0:c}", (decimal)dr["Amount"]);
    }
}
