<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Related.ascx.cs" Inherits="Admin_Controls_Related" %>
<%@ Register TagPrefix="Controls" TagName="EditItem" Src="~/Admin/Controls/EditItem.ascx" %>

<asp:Menu
    id="Menu1"
    Orientation="Horizontal"
    StaticMenuItemStyle-CssClass="tab"
    StaticSelectedStyle-CssClass="selectedTab"
    CssClass="tabs"
    OnMenuItemClick="Menu1_MenuItemClick"
    Runat="server">
    <Items>
    <asp:MenuItem Text="Related Products" Value="0" Selected="true" />
    <asp:MenuItem Text="Add Related Products" Value="1" />
    </Items>    
</asp:Menu>

<div class="tabContents">
    <asp:MultiView ID="mvContent" runat="Server" ActiveViewIndex="0">
        <asp:View ID="vwBasic" runat="server">
            <table>
                <tr>
                    <td>
                        <asp:GridView ID="gvItems" runat="server" GridLines="None" DataKeyNames="SelectorID" AutoGenerateColumns="false" CellSpacing="5" OnRowCommand="gvItems_RowCommand" EmptyDataText="There are no related products currently associated.">
                            <HeaderStyle Font-Size="Small" Font-Bold="false" />
                            <Columns>
                                <asp:TemplateField ItemStyle-Width="40px">
                                    <ItemTemplate>
                                        <asp:CheckBox ID="cbSelect" runat="server" />
                                    </ItemTemplate>
                                </asp:TemplateField>
                                <asp:HyperLinkField DataNavigateUrlFormatString="../EditSelector_Basics.aspx?SelectorID={0}" DataNavigateUrlFields="SelectorID" DataTextField="Name" HeaderText="Name" ItemStyle-Width="340px" />
                            </Columns>
                        </asp:GridView>
                        
                        <% if (gvItems.Rows.Count > 0) { %>
                        <asp:Button ID="btnRemoveSelected" runat="server" Text="Remove Selected" OnClick="btnRemoveSelected_Click" />
                        <% } %>
                    </td>
                </tr>
            </table>
        </asp:View>
        <asp:View ID="vwItemDatabase" runat="server">
            <table>
                <tr>
                    <td>SKU</td>
                    <td>Name</td>
                </tr>
                <tr>
                    <td><asp:TextBox ID="txtSearchSKU" runat="server" Width="130px" /></td>
                    <td><asp:TextBox ID="txtSearchName" runat="server" Width="490px" /></td>
                </tr>
                <tr>
                    <td colspan="5" align="center">
                        <asp:Button ID="btnSearch" runat="server" Text="Search" OnClick="btnSearch_Click" />
                    </td>
                </tr>
            </table>
            
            <br />
            <div align="center">
                <asp:Button ID="btnAdd" runat="server" Text="Add selected to Related Products" OnClick="btnAdd_Click" />
            </div>
            <br />
            
            Searching: <asp:Literal ID="litSearchType" runat="server" />
            <br />
            <br />
            
            <asp:GridView ID="gvItemDatabase" runat="server" GridLines="None" AutoGenerateColumns="false" DataKeyNames="SelectorID">
                <RowStyle VerticalAlign="Top" />
                <Columns>
                    <asp:TemplateField ItemStyle-Width="40px">
                        <ItemTemplate>
                            <asp:CheckBox ID="cbSelect" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="SKU" HeaderText="SKU" ItemStyle-Width="100px" />
                    <asp:BoundField DataField="Name" HeaderText="Name" ItemStyle-Width="500px" />
                </Columns>
            </asp:GridView>
        </asp:View>
    </asp:MultiView>
</div>