<%@ Control Language="C#" AutoEventWireup="true" CodeFile="SelectorCategories.ascx.cs" Inherits="Admin_Controls_SelectorCategories" %>
<%@ Register TagPrefix="Admin" Namespace="Admin" Assembly="__code" %>

<asp:Menu
    id="Menu1"
    Orientation="Horizontal"
    StaticMenuItemStyle-CssClass="tab"
    StaticSelectedStyle-CssClass="selectedTab"
    CssClass="tabs"
    OnMenuItemClick="Menu1_MenuItemClick"
    Runat="server">
    <Items>
    <asp:MenuItem Text="Member of" Value="0" Selected="true" />
    <asp:MenuItem Text="Add to Existing Categories" Value="1" />
    </Items>    
</asp:Menu>

<div class="tabContents">
    <asp:MultiView ID="mvContent" runat="Server" ActiveViewIndex="0">
        <asp:View ID="vwBasic" runat="server">
            <table>
                <tr>
                    <td>
                        <asp:GridView ID="gvCategories" runat="server" GridLines="None" DataKeyNames="CategoryID" AutoGenerateColumns="false" CellSpacing="5" EmptyDataText="This product page is currently not included in any category.  Please use the tabs at the top to place this product page in one or more categories.">
                            <HeaderStyle Font-Size="Small" Font-Bold="false" />
                            <Columns>
                                <asp:TemplateField ItemStyle-Width="40px">
                                    <ItemTemplate>
                                        <asp:CheckBox ID="cbSelect" runat="server" />
                                    </ItemTemplate>
                                </asp:TemplateField>
                                <asp:BoundField DataField="CanonicalName" HeaderText="Category Name" ItemStyle-Width="400px" />
                                <asp:BoundField DataField="UseCategoryLanding" HeaderText="Uses Landing Page?" ItemStyle-Width="150px" HtmlEncode="false" DataFormatString="{0:Yes;;No}" />
                            </Columns>
                        </asp:GridView>
                        
                        <% if (gvCategories.Rows.Count > 0) { %>
                        <asp:Button ID="btnRemoveSelected" runat="server" Text="Remove Selected" OnClick="btnRemoveSelected_Click" />
                        <% } %>
                    </td>
                </tr>
            </table>
        </asp:View>
        <asp:View ID="vwCategoryDatabase" runat="server">
            <table>
                <tr>
                    <td>Category Name</td>
                    <td>Uses Category Landing</td>
                </tr>
                <tr>
                    <td><asp:TextBox ID="txtSearchCanonicalName" runat="server" Width="430px" /></td>
                    <td>
                        <asp:DropDownList ID="ddlSearchUseCategoryLanding" runat="server" Width="150px">
                            <asp:ListItem Value="-1">Select</asp:ListItem>
                            <asp:ListItem Value="1">Yes</asp:ListItem>
                            <asp:ListItem Value="0">No</asp:ListItem>
                        </asp:DropDownList>
                    </td>
                </tr>
                <tr>
                    <td colspan="5" align="center">
                        <asp:Button ID="btnSearch" runat="server" Text="Search" OnClick="btnSearch_Click" />
                    </td>
                </tr>
            </table>
                        
            <br />
            <br />
            Showing: <b><asp:Literal ID="litSearchType" runat="server" /></b>
            <br />
            <% if (gvCategoryDatabase.Rows.Count > 0) { %>
            <br />
            <asp:Button ID="btnAdd" runat="server" Text="Add Selected" OnClick="btnAdd_Click" />
            <br />
            <% } %>
            <br />
            <asp:GridView ID="gvCategoryDatabase" runat="server" GridLines="None" AutoGenerateColumns="false" DataKeyNames="CategoryID">
                <RowStyle VerticalAlign="Top" />
                <Columns>
                    <asp:TemplateField ItemStyle-Width="40px">
                        <ItemTemplate>
                            <asp:CheckBox ID="cbSelect" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="CanonicalName" HeaderText="Category Name" ItemStyle-Width="400px" />
                    <asp:BoundField DataField="UseCategoryLanding" HeaderText="Uses Landing Page?" ItemStyle-Width="150px" HtmlEncode="false" DataFormatString="{0:Yes;;No}" />
                </Columns>
            </asp:GridView>
        </asp:View>
    </asp:MultiView>
</div>