using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_EditAttribute : WebBlocks.AdministrativePage
{
    private int AttributeID
    {
        get { return (ViewState["AttributeID"] == null ? 0 : (int)ViewState["AttributeID"]); }
        set { ViewState["AttributeID"] = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            if (Request["AttributeID"] != null)
                AttributeID = Int32.Parse(Request["AttributeID"]);

            BindData();
        }
    }

    private void BindData()
    {
        DataTable dt = Database.AttributeGroups_GetAll();
        ddlAttributeGroup.DataSource = dt;
        ddlAttributeGroup.DataBind();

        if (AttributeID > 0)
        {
            DataRow dr = Database.Attributes_Get(AttributeID);

            ddlAttributeGroup.SelectedValue = dr["AttributeGroupID"].ToString();
            txtAttributeName.Text = (string)dr["Name"];
        }
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        if (Page.IsValid)
        {
            if (AttributeID == 0)
                Database.Attributes_Add(Int32.Parse(ddlAttributeGroup.SelectedValue), txtAttributeName.Text);
            else
                Database.Attributes_Update(AttributeID, Int32.Parse(ddlAttributeGroup.SelectedValue), txtAttributeName.Text);

            Response.Redirect("ManageAttributes.aspx");
        }

    }
}
