using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_OrderWizard_Cancel : WebBlocks.AdministrativePage
{
    private int OrderID
    {
        get { return (ViewState["OrderID"] == null ? 0 : (int)ViewState["OrderID"]); }
        set { ViewState["OrderID"] = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            OrderID = Int32.Parse(Request["OrderID"]);

            DataRow dr = Database.Orders_GetByOrderID(OrderID);

            if (!(bool)dr["IsAuthorized"])
                wizDelay.ActiveStepIndex = 1;

            if (dr["AdminComments"] != DBNull.Value)
                txtComments.Text = (string)dr["AdminComments"];
        }
    }

    protected void wizDelay_FinishButtonClick(object sender, WizardNavigationEventArgs e)
    {
        // add items back to inventory
        DataTable dtOrderItems = Database.OrderItems_GetByOrderID(OrderID);
        foreach (DataRow drOrderItem in dtOrderItems.Rows)
        {
            DataTable dtItems = Database.Items_Search("", drOrderItem["SKU"].ToString());
            if (dtItems.Rows.Count > 0)
            {
                if (Int32.Parse(dtItems.Rows[0]["Inventory"].ToString()) == -1)
                {
                    // unlimited stock, don't bother adding inventory
                }
                else
                {
                    // item matched up in OrderItems and Items, add inventory back to items
                    Database.Items_Update(Int32.Parse(dtItems.Rows[0]["ItemID"].ToString()), 0, Int32.Parse(drOrderItem["Quantity"].ToString()) + Int32.Parse(dtItems.Rows[0]["Inventory"].ToString()), "", "", 0, 0, null, null, null);
                }
            }
        }

        Database.Orders_UpdateForProcessing(OrderID, txtComments.Text, null, 4, false, null);

        Response.Redirect("EditOrder.aspx?OrderID=" + OrderID.ToString());
    }

    protected void btnVoid_Click(object sender, EventArgs e)
    {
        Gateways.GatewayBase gateway = Gateways.GatewayBase.GetGateway(Configuration.Get("Gateways.PaymentGateway"));
        if (!gateway.VoidFunds(OrderID))
        {
            DataRow dr = Database.Orders_GetByOrderID(OrderID);

            litVoid.Text = "<div style='color: red'>Voiding failed for the following reason:<br>";
            litVoid.Text += (dr["LastResponseText"] == DBNull.Value ? "No Reason" : (string)dr["LastResponseText"]);
            litVoid.Text += "</div>";
        }
        else
            litVoid.Text = "Void successful.";
    }
}
