<%@ Page Language="C#" MasterPageFile="~/Admin/Admin.master" AutoEventWireup="true" CodeFile="OrderWizard_Ship.aspx.cs" Inherits="Admin_OrderWizard_Ship" Title="Shipping Wizard" %>
<asp:Content ID="Content1" ContentPlaceHolderID="LeftNavBar" Runat="Server">
</asp:Content>

<asp:Content ID="Content4" ContentPlaceHolderID="Content" Runat="Server">
    <h1>Shipping Wizard</h1>

    <asp:Wizard DisplaySideBar="false" ID="wizShip" NavigationStyle-HorizontalAlign=Left runat="Server" OnNextButtonClick="wizShip_NextButtonClick" ActiveStepIndex="0">    
        <WizardSteps>
            <asp:WizardStep runat="server" StepType="Start">
                    <asp:Literal runat="server" ID="litPackagesError"></asp:Literal>
                    Enter the number of packages you have in this shipment: <asp:TextBox runat="server" Text="1" ID="txtNumPackages" Width="25px"></asp:TextBox>
            </asp:WizardStep>
            <asp:WizardStep runat="server" StepType="Step">
                    <asp:Repeater runat="server" ID="rptPackages" OnItemDataBound="rptPackages_ItemDataBound">
                        <ItemTemplate>
                        <fieldset>
                            <legend><asp:Literal runat="server" ID="litHeader"></asp:Literal></legend>
                        <table cellpadding="3" cellspacing="3">
                            <tr>
                                <td colspan="2"><asp:Literal runat="Server" ID="litPackageDetailsError"></asp:Literal></td>
                            </tr>
                            <tr>
                                <td>Packaging Type:</td>
                                <td><asp:RadioButtonList runat="server" ID="rdoPackagingTypes" RepeatColumns="4"></asp:RadioButtonList>
                                </td>
                            </tr>
                            <tr>
                                <td>Weight:</td>
                                <td>
                                    <asp:TextBox runat="server" Width="25px" ID="txtWeight" Text="1"></asp:TextBox><asp:DropDownList runat="server" ID="ddlWeightTypes"></asp:DropDownList>
                                </td>
                            </tr>
                            <tr>
                                <td>Insured Value:</td>
                                <td valign="middle">
                                    $ <asp:TextBox runat="server" Width="50px" ID="txtValue" Text="1" ></asp:TextBox>
                                </td>
                            </tr>
                            <tr>
                                <td></td>
                                <td><asp:CheckBox runat="Server" ID="chkLargePackage" Text="Large Package" />&nbsp;(<a href="http://www.ups.com/content/us/en/resources/prepare/dim_weight.html#Large+Package+Conditions" target="_blank" class="smaller nounderline">What is a large package?</a>)</td>
                            </tr>
                            </table>
                            </fieldset>
                            <br />
                        </ItemTemplate>
                    </asp:Repeater>
            </asp:WizardStep>
            <asp:WizardStep runat="server" StepType="Step">
                <asp:Literal runat="server" ID="litShippingMethodError"></asp:Literal>
                <fieldset>
                    <legend>Select your shipping method</legend>
                    <table cellpadding="3" cellspacing="3">
                        <tr>
                        <td align="center">Customer selected<br /><b><span style="color: Red;font-size:larger;"><asp:Literal runat="server" ID="litCustomerShippingMethod"></asp:Literal></span></b></div>
                        </td>
                        </tr>
                        <tr>
                            <td><asp:RadioButtonList runat="server" ID="rdoShippingMethods" CellPadding="3" CellSpacing="3" RepeatColumns="3"></asp:RadioButtonList>
                            </td>
                        </tr>
                        </table>
                        </fieldset>
            </asp:WizardStep>
            <asp:WizardStep runat="server" StepType="Step" AllowReturn="False">
                <asp:Literal runat="server" ID="litAcceptError"></asp:Literal>
                The total charge for this shipment is: <asp:Literal runat="server" ID="litTotalCharge"></asp:Literal>
                <br /><br />
                UPS Tracking Number: <asp:Literal runat="server" ID="litTrackingNumber"></asp:Literal>
                <br /><br />
                Click "Next" to confirm this charge to your UPS Account and view the shipping label or "Previous" to make changes to your shipment.           
            </asp:WizardStep>
            <asp:WizardStep runat="server" StepType="Step" AllowReturn="False" ID="wizStep_Finish">
                Your shipment has been successfully processed. If you'd like to send an e-mail to your customer informing them that their product has shipped, you can do so now.  Use the field below to specify any additional comments.  The tracking number will be included in the e-mail.
                <br />
                <br />
                <asp:Literal runat="server" ID="litPrintShipingLabel"></asp:Literal>
                <asp:Literal runat="server" ID="litHighValueReport"></asp:Literal>
                <br />
                <br />
                Comments:
                <table>
                    <tr>
                        <td><asp:TextBox ID="txtComments" runat="server" TextMode="MultiLine" Width="600px" Height="200px" /></td>
                    </tr>
                </table>     
                <asp:CheckBox ID="chkSendEmail" runat="server" Text="Send customer a shipment sent e-mail" Checked="True" /><br />         
            </asp:WizardStep>
            <asp:WizardStep runat="server" StepType="Finish" AllowReturn="False">
                    <asp:Literal runat="Server" ID="litShipped"></asp:Literal>
            </asp:WizardStep>
        </WizardSteps>
        <NavigationStyle HorizontalAlign="Left" />
        <FinishNavigationTemplate>
            <br /><asp:Button ID="btnCaptureFunds" runat="server" CausesValidation="False" CommandName="CaptureFunds"
                Text="Capture Funds" OnClick="btnCaptureFunds_Click" />
            <asp:Button ID="btnFinish" runat="server" CommandName="Finish" Text="Finish" OnClick="btnFinish_Click" />
        </FinishNavigationTemplate>
    </asp:Wizard>

</asp:Content>

