using System;
using System.Data;

using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace AdminControls
{
    public class OrderContentsControl : WebBlocksControl
    {
        private int _OrderID = 0;
        public int OrderID
        {
            set { _OrderID = value; }
        }


        protected Table tbOrderContents;

        protected override void Render(HtmlTextWriter writer)
        {
            writer.Write("<table class=\"OrderContents\">\n");
            writer.Write("<tr><th class=\"quantity\">Quantity</th><th class=\"productname\">Product Name</th><th class=\"properties\"></th><th class=\"unitprice\">Unit Price</th><th class=\"cost\">Cost</th></tr>");

            DataTable dt = Database.OrderItems_GetByOrderID(_OrderID);

            double total = 0;
            foreach (DataRow drx in dt.Rows)
            {
                writer.Write("<tr valign=\"top\"><td class=\"quantity\">");
                writer.Write(drx["Quantity"].ToString());
                writer.Write("</td><td class=\"productname\">");
                writer.Write((string)drx["Name"]);
                writer.Write("</td>");
                writer.Write("<td class=\"unitprice\">");
                writer.Write(((decimal)drx["Price"]).ToString("C"));
                writer.Write("</td>");
                writer.Write("<td class=\"cost\">");
                writer.Write(((decimal)drx["Cost"]).ToString("C"));
                writer.Write("</td>");
                total += (double)(decimal)drx["Cost"];

                writer.Write("</tr>");
            }

            // select order information
            DataRow dr = Database.Orders_GetByOrderID(_OrderID);

            // get discounts
            DataTable dtDiscounts = Database.OrderDiscounts_GetByOrderID(_OrderID);

            if (dr != null)
            {
                writer.Write("<tr><td></td><td align='right'>Sub Total</td><td></td><td></td><td>");
                writer.Write(total.ToString("C"));
                writer.Write("</td></tr>");
                writer.Write("<tr><td></td><td align='right'>Tax</td><td><span style='color: red'>");
                writer.Write(((decimal)dr["TaxAmount"] > 0 ? "Tax Charged" : "Tax Not Charged"));
                writer.Write("</span></td><td></td><td>");
                writer.Write(((decimal)dr["TaxAmount"]).ToString("C"));
                writer.Write("</td></tr>");

                foreach (DataRow drDiscount in dtDiscounts.Rows)
                {
                    writer.Write("<tr><td></td><td align='right'>Discount</td><td><span style='color: red'>");
                    writer.Write((string)drDiscount["DiscountName"]);
                    writer.Write("</span></td><td></td><td>");
                    writer.Write((-(decimal)dr["DiscountAmount"]).ToString("C"));
                    writer.Write("</td></tr>");
                }                    

                writer.Write("<tr><td></td><td align='right'>Shipping</td><td><span style='color: red'>");
                writer.Write((string)dr["ShippingMethod"]);
                writer.Write("</span></td><td></td><td>");
                writer.Write(((decimal)dr["ShippingAmount"]).ToString("C"));
                writer.Write("</td></tr>");
                writer.Write("<tr><td></td><td align='right'>Grand Total</td><td></td><td></td><td>");
                writer.Write(((decimal)dr["Amount"]).ToString("C"));
                writer.Write("</td></tr>");
            }

            writer.Write("</table>");
        }
    }
}
