using System;
using System.Data;
using System.Web.UI;

namespace Estore.CustomizationControls
{
    public abstract class CustomizationControlBase : WebBlocksControl
    {
        public abstract string Text
        {
            get;
        }

        public abstract decimal SelectedCustomizationCost
        {
            get;
        }

        public int CustomizationID
        {
            get { return (ViewState["CustomizationID"] == null ? 0 : (int)ViewState["CustomizationID"]); }
            set { ViewState["CustomizationID"] = value; }
        }

        public string Label
        {
            get { return (ViewState["Label"] == null ? "" : (string)ViewState["Label"]); }
            set { ViewState["Label"] = value; }
        }

        public string Name
        {
            get { return (ViewState["Name"] == null ? "" : (string)ViewState["Name"]); }
            set { ViewState["Name"] = value; }
        }

        public abstract void BindOptions(DataTable dt);

        public virtual void RenderTableRow(HtmlTextWriter writer)
        {
            writer.Write("<tr>");
            writer.Write("<td><b>");
            writer.Write(Label);
            writer.Write("</b><br>");
            base.Render(writer);
            writer.Write("</td>");
            writer.Write("</tr>");
        }
    }
}