using System;
using System.Data;
using System.Collections.Generic;
using System.Collections;
using System.Text;

public class CustomizationEntry
{
    public DatabaseClass.Enumerations.CustomizationControlTypes ControlType;
    public int CustomizationID;
    public string Name;

    public CustomizationEntry(DatabaseClass.Enumerations.CustomizationControlTypes cType, int cId, string cName)
    {
        ControlType = cType;
        CustomizationID = cId;
        Name = cName;
    }
}

public class CustomizationList : Dictionary<CustomizationEntry, string>
{
	public CustomizationList(int capacity) : base(capacity)
	{
	}

    public decimal CustomizationCost = 0;

    public override string ToString()
    {
        StringBuilder sb = new StringBuilder();

        foreach (CustomizationEntry ce in this.Keys)
        {
            sb.Append(ce.Name);
            sb.Append(": ");
            if (ce.ControlType == DatabaseClass.Enumerations.CustomizationControlTypes.FileUpload)
            {
                string FileURL = this[ce];
                string FileName = FileURL.Substring(FileURL.LastIndexOf('/') + 1);

                sb.Append("<a href=\"");
                sb.Append(FileURL);
                sb.Append("\">");
                sb.Append(FileName);
                sb.Append("</a>");
            }
            else
            {
                sb.Append(this[ce]);
            }
            sb.Append("<br>");
        }

        sb = sb.Remove(sb.Length - 4, 4);

        return sb.ToString();
    }
}
