<%@ Page Language="C#" MasterPageFile="~/Content.master" AutoEventWireup="true" CodeFile="Checkout.aspx.cs" Inherits="Checkout" Title="Checkout: Billing Information" %>
<%@ Register TagPrefix="Controls" TagName="CartControl" Src="~/Controls/CartControl.ascx" %>
<%@ Register TagPrefix="Controls" TagName="CheckoutNavigation" Src="~/Controls/CheckoutNavigation.ascx" %>
<%@ Register TagPrefix="Controls" TagName="Payment" Src="~/Controls/Payment.ascx" %>

<asp:Content ID="Content2" ContentPlaceHolderID="ContentArea" Runat="Server">
<table class="fullContentArea" cellpadding="0" cellspacing="0">
    <tr>
        <td class="fullContentOpen">&nbsp;</td>
    </tr>
    <tr valign="top">
        <td class="fullContentSpan">
            <div class="pageHeader"><img src="images/page-hdr-checkout.gif" alt="Checkout" /></div>
            <table class="cartPage" align="center" cellpadding="0" cellspacing="0">
                <tr>
                    <td>
                        <Controls:CheckoutNavigation runat="Server" ID="CheckoutNav1" />
                        <br />
                        <div class="cartHeader">Your Cart</div>
                        <Controls:CartControl ID="CartControl1" runat="server" IsEditable="False" />
                        <br />
                        <asp:ValidationSummary ID="valSummary" runat="Server" DisplayMode="SingleParagraph" HeaderText="<div class='validation'>Some required fields are missing.  Please ensure that all fields marked with a red asterisk (*) are filled out accurately.</div>" ValidationGroup="valCheckout" />
                        
                        <div class="checkoutHeader">Billing Information</div>
                        <table class="checkoutTwoColumn" cellpadding="0" cellspacing="0">
                            <tr valign="top">
                                <td class="column1">
                                    <div class="checkoutArea">
                                        <div class="checkoutSubHeader">Provide Your Billing Information</div>
                                        <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                            <% if (CustomerInfo != null && ddlUseExistingBilling.Items.Count > 0) { %>
                                                <tr>
                                                    <td class="formLabel">
                                                        Billing Address:
                                                    </td>
                                                    <td>
                                                        <asp:DropDownList ID="ddlUseExistingBilling" runat="server" AutoPostBack="true" OnSelectedIndexChanged="ddlUseExistingBilling_SelectedIndexChanged" />
                                                    </td>
                                                </tr>
                                            <% } %>
                                            <tr>
                                                <td class="formLabel"></td>
                                                <td><asp:CheckBox ID="chkSameAsShipping" runat="server" AutoPostBack="true" Text="Same as shipping address" OnCheckedChanged="chkSameAsShipping_CheckedChanged" /></td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    <asp:RequiredFieldValidator ControlToValidate="txtBillFirstName" ID="RequiredFieldValidator1" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>First Name:</td>
                                                <td><asp:TextBox ID="txtBillFirstName" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="txtBillLastName" ID="RequiredFieldValidator2" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Last Name:</td>
                                                <td><asp:TextBox ID="txtBillLastName" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="txtBillAddress" ID="RequiredFieldValidator3" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Address:</td>
                                                <td><asp:TextBox ID="txtBillAddress" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="txtBillCity" ID="RequiredFieldValidator4" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>City:</td>
                                                <td><asp:TextBox ID="txtBillCity" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="ddlBillState" InitialValue="" ID="RequiredFieldValidator5" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>State:</td>
                                                <td><asp:DropDownList ID="ddlBillState" runat="server" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="ddlBillCountry" InitialValue="" ID="RequiredFieldValidator6" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Country:</td>
                                                <td><asp:DropDownList ID="ddlBillCountry" runat="server" CssClass="inputBox" Enabled="false" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="txtBillZipCode" ID="RequiredFieldValidator7" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Zip Code:</td>
                                                <td><asp:TextBox ID="txtBillZipCode" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="txtBillPhone" ID="RequiredFieldValidator75" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Phone Number:</td>
                                                <td><asp:TextBox ID="txtBillPhone" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                        </table>
                                    </div>
                                </td>
                                <td class="column2">
                                    <div class="checkoutArea">
                                        <div class="checkoutSubHeader">Payment Information</div>
                                        <Controls:Payment ID="Payment1" runat="Server" ValidationGroup="valCheckout" />
                                    </div>
                                    <div class=checkoutArea">
                                        <asp:CheckBox runat="Server" ID="chkMailingList" Checked="true" Text="Sign me up for the mailing list" />
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <br />
                        <center>
                            <asp:ImageButton ID="btnSubmit" ValidationGroup="valCheckout" runat="server" ImageAlign="AbsMiddle" ImageUrl="images/submit.gif" OnClick="btnSubmit_Click" />
                            <br /><br />
                            <img src="images/veri-sign.gif" alt="VeriSign" />
                        </center>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td class="fullContentClose">&nbsp;</td>
    </tr>
</table>
</asp:Content>

