<%@ Control Language="C#" AutoEventWireup="true" CodeFile="CartControl.ascx.cs" Inherits="Controls_CartControl" %>

<div style="width: 100%;"><asp:Literal ID="litInventoryCheckError" runat="server" /></div>
<table cellspacing="0" cellpadding="5" class="cartControl">
<% if (ShoppingCart.Count > 0) { %>
    <tr>
        <th></th>
        <th>Quantity</th>
        <th align="left">Product</th>
        <th align="right">Unit Price</th>
        <th align="right">Total Price</th>
    </tr> 
    <asp:Repeater ID="rptShoppingCart" runat="server" OnItemCommand="rptShoppingCart_ItemCommand">
        <ItemTemplate>
            <tr>
                <% if (IsEditable)  { %>
                <td class="removeColumn">
                    <asp:ImageButton ID="btnRemove" runat="server" ImageUrl="~/images/remove.gif" ImageAlign="AbsMiddle" CommandName="Delete" CommandArgument='<%# Eval("CartItemID") %>' />
                </td>
                <% } else { %>
                <td class="removeColumn">&nbsp;</td>
                <% } %>
                
                <td class="quantityColumn">
                    <% if (IsEditable) { %>
                    <asp:TextBox ID="txtQuantity" runat="server" Text='<%# Eval("Quantity") %>' MaxLength="4" Width="30px" />
                    <% } else { %>
                    <%# Eval("Quantity") %>
                    <% } %>
                </td>
                <td class="nameColumn">
                    <b><%# Eval("Name") %> (<%# Eval("SKU") %>)</b><br />
                    <%# Eval("CustomizationText") %>
                </td>
                <td class="unitPriceColumn"><b><%# Eval("CustomizedPrice", "{0:c}")%></b></td>
                <td class="totalPriceColumn"><b><%# Eval("ItemTotal","{0:C}") %></b></td>
            </tr>
        </ItemTemplate>
    </asp:Repeater>
    <tr>
        <td>&nbsp;</td>
        <td align="center">
            <% if (IsEditable)  { %>
            <asp:LinkButton ID="lbUpdate" runat="server" Text="Update" OnClick="lbUpdate_Click" />
            <% } %>            
        </td>
        <td align="right" colspan="2">Sub Total:</td>
        <td align="right"><b><%= String.Format("{0:C}", ShoppingCart.SubTotal) %></b></td>
    </tr>
    <asp:Repeater ID="rptDiscounts" runat="server" OnItemCommand="rptDiscounts_ItemCommand">
        <ItemTemplate>
        <tr>
            <td colspan="2">&nbsp;</td>
            <td align="right" colspan="2">
                <%# Eval("DiscountTitle") %> <asp:LinkButton ID="lbRemoveDiscount" runat="server" Text="[remove]" CommandArgument='<%# Eval("DiscountCode") %>' CommandName="del" />:
            </td>
            <td align="right"><b>-<%# Eval("DiscountAmount", "{0:C}") %></b></td>
        </tr>
        </ItemTemplate>
    </asp:Repeater>
    <% if (ShoppingCart.RequiresSalesTax && ShoppingCart.SalesTax > 0) { %>
        <tr>
            <td colspan="2">&nbsp;</td>
            <td align="right" colspan="2"><%= ShoppingCart.TaxState %> Sales Tax (<%= String.Format("{0:f}", ShoppingCart.TaxRate*100) %>%):</td>
            <td align="right"><b><%= String.Format("{0:c}", ShoppingCart.SalesTax) %></b></td>
        </tr>
    <% } %>
    <% if (ShoppingCart.ShippingName.Length > 0 && !ShoppingCart.IsFreeShipping) { %>
    <tr>
        <td colspan="2">&nbsp;</td>
        <td align="right" valign="top" colspan="2">
            Shipping and Handling
            <% if (ShoppingCart.ShippingName != string.Empty) { %>
                (<%= ShoppingCart.ShippingName%>)
            <% } %>:
        </td>
        <td align="right"><b>
        <%= String.Format("{0:C}", ShoppingCart.ShippingCost) %>
        </b></td>
    </tr>
    <% } %>
    <tr>
        
        <% if (IsEditable) { %>
            <td colspan="2">&nbsp;</td>
            <td align="right" colspan="2">Total:</td>
        <% } else { %>
            <td></td>
            <td colspan="2">
                Need to make a change to quantities? <a href="Cart.aspx">Click here.</a>
            </td>
            <td align="right">Total:</td>
        <% } %>        
        <td align="right"><b><%= String.Format("{0:C}", ShoppingCart.GrandTotal)%></b></td>
    </tr>
<% } else { %>
    <tr><td>Your cart is empty.</td></tr>
<% } %>
</table>