using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Controls_CheckoutNavigation : WebBlockUserControl
{
    protected override void Render(HtmlTextWriter writer)
    {
        OrderInfo oi = (OrderInfo)Session["OrderInfo"];
        ShoppingCart sc = WebBlockPage.ShoppingCart;
        
        if (oi != null)
        {
            writer.Write("<table><tr><td>");
            // always show PreCheckout link
            writer.Write("<a href='PreCheckout.aspx'>Shipping Information</a>&nbsp;&nbsp;>&nbsp;&nbsp;");
            writer.Write("</td><td>");
            // show Shipping options only if shipping address has been set
            if (oi.ShippingAddressID > 0)
                writer.Write("<a href='ShippingOptions.aspx'>Shipping Options</a>&nbsp;&nbsp;>&nbsp;&nbsp;");
            else
                writer.Write("Shipping Options&nbsp;&nbsp;>&nbsp;&nbsp;");

            writer.Write("</td><td>");

            // show billing info only if shipping method is set
            if (sc.ShippingName.Length > 0)
                writer.Write("<a href='Checkout.aspx'>Billing Information</a>&nbsp;&nbsp;>&nbsp;&nbsp;");
            else
                writer.Write("Billing Information&nbsp;&nbsp;>&nbsp;&nbsp;");

            writer.Write("</td><td>");

            // show confirm only if billing id is set
            if (sc.ShippingName.Length > 0 && oi.BillingAddressID > 0)
                writer.Write("<a href='ConfirmOrder.aspx'>Confirm</a>");
            else
                writer.Write("Confirm");

            writer.Write("</td></tr></table>");
        }
    }
}
