using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Controls_ImageView : WebBlockUserControl
{
    private int _SelectorID;
    public int SelectorID
    {
        get { return _SelectorID; }
        set { _SelectorID = value; }
    }

    private string _DefaultPhotoSetID = "";
    public string DefaultPhotoSetID
    {
        get { return _DefaultPhotoSetID; }
    }

    private string _DefaultCaption = "";
    public string DefaultCaption
    {
        get { return _DefaultCaption; }
    }

    private string _DefaultPhoto = "";
    public string DefaultPhoto
    {
        get
        {
            if (System.IO.File.Exists(Server.MapPath("ProductPhotos/" + _DefaultPhoto)))
                return _DefaultPhoto;
            else
                return "noPhoto.gif";
        }
    }

    public void BindData()
    {
        DataTable dt = Database.PhotoSets_GetBySelectorID(SelectorID);

        if (dt.Rows.Count > 0)
        {
            _DefaultPhotoSetID = dt.Rows[0]["PhotoSetID"].ToString();
            _DefaultPhoto = (string)dt.Rows[0]["Filename"];
            _DefaultCaption = (string)dt.Rows[0]["Caption"];

            if (dt.Rows.Count > 1)
            {
                rptThumbs.DataSource = dt;
                rptThumbs.DataBind();
            }
        }
        else
        {
            _DefaultCaption = "No Photo Available";
            _DefaultPhotoSetID = "0";
            _DefaultPhoto = "noPhoto.gif";
        }
    }

    protected void rptThumbs_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            Image imgThumbnail = (Image)e.Item.FindControl("imgThumbnail");

            string mediumImage = (string)DataBinder.Eval(e.Item.DataItem, "Filename");
            if (!System.IO.File.Exists(Server.MapPath("ProductPhotos/" + mediumImage)))
                mediumImage = "noPhoto.gif";

            string caption = (string)DataBinder.Eval(e.Item.DataItem, "Caption");

            imgThumbnail.Attributes.Add("OnClick", "swapImg('" + escapeForJavascript(mediumImage) + "','" + escapeForJavascript(caption) + "'," + DataBinder.Eval(e.Item.DataItem, "PhotoSetID") + "); return false;");
            imgThumbnail.Attributes.Add("border", "0");
            imgThumbnail.CssClass = "smallImg";
            imgThumbnail.AlternateText = caption;
            imgThumbnail.ImageUrl = "../LiveImage.ashx?preset=small&img=ProductPhotos/" + mediumImage;
        }
    }

    protected string escapeForJavascript(string str)
    {
        str = str.Replace("'", "\\'");
        return str;
    }
}
