using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Controls_NewAccount : WebBlockUserControl
{
    public string RedirectURL
    {
        get { return (string)Session["RedirectURL"]; }
        set { Session["RedirectURL"] = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            regexEmail.ValidationExpression = "^([a-zA-Z0-9_\\-\\.]+)@([a-zA-Z0-9_\\-\\.]+)\\.([a-zA-Z]{2,5})$";
        }
    }

    protected void imgLogin_Click(object sender, ImageClickEventArgs e)
    {
        Page.Validate("NewAccount");
        if (Page.IsValid)
        {
            lblError.Visible = false;

            DataRow dr = Database.Customers_GetNonOneTimeByEmailAddress(txtEmailAddress.Text, null);

            if (dr != null)
            {
                lblError.Visible = true;
                lblError.Text = "E-mail address has already been registered to an account";
            }
            else
            {
                int CustomerID = Database.Customers_Add(txtEmailAddress.Text, txtPassword.Text, false, true);
                CustomerInfo = new CustomerInfo();
                CustomerInfo.CustomerID = CustomerID;
                CustomerInfo.EmailAddress = txtEmailAddress.Text;
                CustomerInfo.OneTimeCustomer = false;

                if (RedirectURL != null)
                    Response.Redirect(RedirectURL, false);
            }
        }
    }
}

