using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Controls_SingleLineLogin : WebBlockUserControl
{
    public event EventHandler SuccessfulLogin;

    public string RedirectURL
    {
        get { return (string)Session["RedirectURL"]; }
        set { Session["RedirectURL"] = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            regexEmail.ValidationExpression = "^([a-zA-Z0-9_\\-\\.]+)@([a-zA-Z0-9_\\-\\.]+)\\.([a-zA-Z]{2,5})$";
        }
    }

    protected void imgLogin_Click(object sender, ImageClickEventArgs e)
    {
        Page.Validate("Login");
        if (Page.IsValid)
        {
            if (SuccessfulLogin != null)
                SuccessfulLogin(this, new EventArgs());
            else
            {
                if (RedirectURL != null)
                    Response.Redirect(RedirectURL, false);
                else
                    Response.Redirect("Default.aspx", false);
            }
        }
    }

    protected void custLogin_ServerValidate(object source, ServerValidateEventArgs args)
    {
        DataRow dr = Database.Customers_GetNonOneTimeByEmailAddressAndPassword(txtEmailAddress.Text, txtPassword.Text);

        if (dr != null)
        {
            CustomerInfo = new CustomerInfo();
            CustomerInfo.CustomerID = (int)dr["CustomerID"];
            CustomerInfo.EmailAddress = (string)dr["EmailAddress"];
            CustomerInfo.OneTimeCustomer = false;
            args.IsValid = true;
        }
        else
            args.IsValid = false;
    }
}

