<%@ Page Language="C#" MasterPageFile="~/Content.master" AutoEventWireup="true" CodeFile="PreCheckout.aspx.cs" Inherits="PreCheckout" Title="Checkout: Shipping Information" %>
<%@ Register TagPrefix="Controls" TagName="CartControl" Src="~/Controls/CartControl.ascx" %>
<%@ Register TagPrefix="Controls" TagName="CheckoutNavigation" Src="~/Controls/CheckoutNavigation.ascx" %>
<%@ Register TagPrefix="Controls" TagName="SingleLineLogin" Src="~/Controls/SingleLineLogin.ascx" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentArea" Runat="Server">
<table class="fullContentArea" cellpadding="0" cellspacing="0">
    <tr>
        <td class="fullContentOpen">&nbsp;</td>
    </tr>
    <tr valign="top">
        <td class="fullContentSpan">
            <div class="pageHeader"><img src="images/page-hdr-checkout.gif" alt="Checkout" /></div>
            <table class="cartPage" align="center" cellpadding="0" cellspacing="0">
                <tr>
                    <td>
                        <Controls:CheckoutNavigation runat="Server" ID="CheckoutNav1" />
                        <br />
                        <div class="cartHeader">Your Cart</div>
                        <Controls:CartControl ID="CartControl1" runat="server" IsEditable="False" />
                        
                        <asp:ValidationSummary ID="valSummary" runat="Server" DisplayMode="SingleParagraph" HeaderText="<div class='validation'>Some required fields are missing</div>" ValidationGroup="valCheckout" />
                                    
                        <br />
                        <asp:Panel ID="pnlDiscount" runat="server" DefaultButton="btnEnter">Promotional Code: <asp:TextBox ID="txtDiscountCode" runat="Server" MaxLength="255" CssClass="discountBox" /> <asp:Button ID="btnEnter" runat="server" Text="Enter Code" OnClick="btnEnter_Click" CssClass="discountButton" CausesValidation="false" /></asp:Panel>
                        <br />
                        <div class="checkoutHeader">Checkout - Step 1</div>
                        <table class="checkoutTwoColumn" cellpadding="0" cellspacing="0">
                            <tr valign="top">
                                <td class="column1">
                                    <asp:Panel runat="server" DefaultButton="btnSubmit">
                                        <div class="checkoutSubHeader">Provide Shipping Information for Recipient</div>
                                        <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                            <tr>
                                                <td class="formLabel"><asp:RequiredFieldValidator ControlToValidate="txtShipFirstName" ID="RequiredFieldValidator11" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>First Name:</td>
                                                <td><asp:TextBox ID="txtShipFirstName" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="txtShipLastName" ID="RequiredFieldValidator12" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Last Name:</td>
                                                <td><asp:TextBox ID="txtShipLastName" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="txtShipAddress" ID="RequiredFieldValidator13" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Address:</td>
                                                <td><asp:TextBox ID="txtShipAddress" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="txtShipCity" ID="RequiredFieldValidator14" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>City:</td>
                                                <td><asp:TextBox ID="txtShipCity" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="ddlShipState" InitialValue="" ID="RequiredFieldValidator15" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>State:</td>
                                                <td><asp:DropDownList ID="ddlShipState" runat="server" CssClass="inputBox" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="ddlShipCountry" InitialValue="" ID="RequiredFieldValidator16" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Country:</td>
                                                <td><asp:DropDownList ID="ddlShipCountry" runat="server" CssClass="inputBox" Enabled="false" /></td>
                                            </tr>
                                            <tr>
                                                <td><asp:RequiredFieldValidator ControlToValidate="txtShipZipCode" ID="RequiredFieldValidator17" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Zip Code:</td>
                                                <td><asp:TextBox ID="txtShipZipCode" runat="Server" MaxLength="255" CssClass="inputBox" /></td>
                                            </tr>
                                        </table>
                                        
                                        <br />
                                        
                                        <div class="checkoutSubHeader">Gift Message</div>
                                        <div>If this is a gift, you can enter a message for the recipient here.</div>
                                        <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                            <tr>
                                                <td><asp:TextBox ID="txtComments" Width="300px" Height="50px" MaxLength="300" TextMode="MultiLine" runat="server" CssClass="inputBox comments" /></td>
                                            </tr>
                                        </table>
                                    </asp:Panel>
                                </td>
                                <td class="column2">
                                    <% if (CustomerInfo == null) { %>
                                    <div class="checkoutSubHeader">Log in for faster checkout</div>
                                    <div>Login here to use your existing account information.</div>
                                    <div><Controls:SingleLineLogin ID="SingleLineLogin1" runat="Server" /></div>
                                    
                                    <% } %>
                                    
                                    <% if (CustomerInfo != null && ddlUseExistingShipping.Items.Count > 0) { %>
                                    <div class="checkoutSubHeader">Use Existing Shipping Address:</div>
                                    <asp:DropDownList ID="ddlUseExistingShipping" runat="server" AutoPostBack="true" OnSelectedIndexChanged="ddlUseExistingShipping_SelectedIndexChanged" />
                                    <% } %>
                                    <% if (CustomerInfo == null) { %>
                                    <br />
                                    <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                        <tr>
                                        <td width="49%"><hr /></td>
                                        <td align="center"><b>OR</b></td>
                                        <td width="49%"><hr /></td>
                                        </tr>
                                     </table>
                                     <% } %>
                                     <br /><br />
                                    <div class="checkoutSubHeader">Your Information</div>
                                    <div>We'll be using this e-mail address to send updates on your order.</div>
                                    <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                        <tr>
                                            <td><asp:RequiredFieldValidator ControlToValidate="txtEmailAddress" ID="RequiredFieldValidator8" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Your Email Address:</td>
                                            <td><asp:TextBox ID="txtEmailAddress" runat="Server" MaxLength="255" CssClass="inputBox" /><br />
                                            <asp:CustomValidator ID="custEmailAddress" runat="Server" ErrorMessage="That email address is already in use.  Did you forget to <a href='LogIn.aspx'>log in</a> or <a href='ForgotPassword.aspx'>forget your password?</a>" Display="Dynamic" ValidationGroup="valCheckout" OnServerValidate="custEmailAddress_ServerValidate" /></td>
                                        </tr>
                                        <tr>
                                            <td>
                                            <asp:RequiredFieldValidator ControlToValidate="txtEmailAddress2" ID="RequiredFieldValidator1" runat="server" Display="Dynamic" ValidationGroup="valCheckout">*</asp:RequiredFieldValidator><font color="red">*</font>Confirm Your Email Address:</td>
                                            <td><asp:TextBox ID="txtEmailAddress2" runat="Server" MaxLength="255" CssClass="inputBox" />
                                            <asp:CompareValidator ControlToValidate="txtEmailAddress2" ID="cmpEmail" runat="server" Display="Dynamic" ErrorMessage="<br>Email Addresses must match" ControlToCompare="txtEmailAddress" ValidationGroup="valCheckout"></asp:CompareValidator>
                                            </td>
                                        </tr>
                                     </table>
                                     <br /><br />
                                    <% if (CustomerInfo == null) { %>
                                        <div class="checkoutSubHeader">Create an account by typing in a password (optional)</div>
                                        <div>If you create an account, you can login to the site later to view your order history.  Leave the password fields blank if you do not wish to create an account.</div>
                                        <table width="100%" class="checkoutForm" cellpadding="0" cellspacing="0">
                                            <tr>
                                                <td class="formLabel">Password:</td>
                                                <td>
                                                    <asp:TextBox ID="txtPassword" runat="Server" MaxLength="255" CssClass="inputBox" TextMode="Password" />
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>Password (re-type):</td>
                                                <td>
                                                    <asp:TextBox ID="txtPasswordConfirm" runat="Server" MaxLength="255" CssClass="inputBox" TextMode="Password" /><asp:CompareValidator ControlToValidate="txtPasswordConfirm" ControlToCompare="txtPassword" ID="CompareValidator1" runat="server" ValidationGroup="valCheckout" Display="dynamic"><br />Passwords must match</asp:CompareValidator>
                                                </td>
                                            </tr>
                                            
                                            <tr>
                                                <td colspan="2">
                                                    <asp:Label ID="lblError" runat="server" ForeColor="Red"></asp:Label>
                                                </td>
                                            </tr>
                                            <tr>
                                            
                                        </tr>
                                        </table>  
                                        <% } %> 
   
                                    
                                </td>
                            </tr>
                            <tr>
                                <td colspan="2" align="center"><br /><asp:ImageButton ID="btnSubmit" ValidationGroup="valCheckout" runat="server" ImageAlign="AbsMiddle" ImageUrl="images/submit.gif" OnClick="btnSubmit_Click" /></td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td class="fullContentClose">&nbsp;</td>
    </tr>
</table>
</asp:Content>

