using System;
using System.Data;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : WebBlockPage
{
    public int CategorySelectorMapID
    {
        get { return (ViewState["CategorySelectorMapID"] == null ? 0 : (int)ViewState["CategorySelectorMapID"]); }
        set { ViewState["CategorySelectorMapID"] = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            if (Request["CategorySelectorMapID"] != null)
                CategorySelectorMapID = Int32.Parse(Request["CategorySelectorMapID"]);
            else if (Request.PathInfo.Length > 0)
            {
                try
                {
                    string idText = Request.PathInfo.Substring(1, Request.PathInfo.IndexOf('/', 1) - 1);
                    CategorySelectorMapID = Int32.Parse(idText);
                }
                catch
                {
                    throw new Exception("Malformed query string.");
                }
            }
            else
                Response.Redirect("Default.aspx"); // fail gracefully
        }


        DataRow dr = Database.Selectors_GetByCategorySelectorMapID(CategorySelectorMapID);

        if (dr == null)
            throw new Exception("Please use a valid CategorySelectorMapID");
        else
        {
            /* bind category-based controls */
            int CategoryID = (int)dr["CategoryID"];
            //ProductNav1.SelectedCategoryID = CategoryID;
            Breadcrumbs1.SelectedCategoryID = CategoryID;

            /* bind selector-based control */
            SelectorData sd = new SelectorData();
            sd.SelectorID = (int)dr["SelectorID"];
            sd.SelectorType = (string)dr["SelectorType"];
            sd.Name = (string)dr["Name"];
            sd.Description = (string)dr["Description"];
            sd.TextPrice = (string)dr["TextPrice"];
            sd.SKU = ((string)dr["SKU"] ?? "");
            esProductDetails.BindData(sd);

            // set the page title
            string PageTitle = ConfigurationManager.AppSettings["EstorePageTitle"];
            if (PageTitle != null)
                Page.Title = String.Format("{0} - {1}", sd.Name, PageTitle);
            else
                Page.Title = sd.Name;
        }
    }
}
